/**
 * NOTE: This class is auto generated by the swagger code generator program (2.2.3).
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */
package io.swagger.api;

import io.swagger.model.CountryDTO;

import io.swagger.annotations.*;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestHeader;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RequestPart;
import org.springframework.web.multipart.MultipartFile;

import java.util.List;
import javax.validation.constraints.*;
import javax.validation.Valid;
@javax.annotation.Generated(value = "io.swagger.codegen.languages.SpringCodegen", date = "2021-01-10T17:43:13.345Z")

@Api(value = "borderInfo", description = "the borderInfo API")
public interface BorderInfoApi {

    @ApiOperation(value = "An API to query which countries use the provided ISO 4217 formatted currency code.", notes = "returns a JSON object containing 2 lists. 1st list is named 'supportedCountryCodes' and contains the country codes which use the provided currency code. 2nd list is named 'borderCountryCodes' and contains the country codes for the countries who share physical borders with those in the first list but which do not share the provided currency code. Both lists of country codes are formatted in ISO 3166-1 format, example 'GB'", response = CountryDTO.class, tags={  })
    @ApiResponses(value = { 
        @ApiResponse(code = 200, message = "OK", response = CountryDTO.class),
        @ApiResponse(code = 400, message = "Bad request, currency parameter must be a string of 2 - 3 letters.", response = Void.class),
        @ApiResponse(code = 404, message = "Provided currency code not found.", response = Void.class),
        @ApiResponse(code = 503, message = "Service unavailable.", response = Void.class) })
    
    @RequestMapping(value = "/borderInfo",
        produces = { "application/json" }, 
        method = RequestMethod.GET)
    default ResponseEntity<CountryDTO> borderInfoGet( @Pattern(regexp="^[a-zA-Z]{2,3}$")@ApiParam(value = "ISO 4217 formatted currency code, example 'GBP'") @RequestParam(value = "currency", required = false) String currency) {
        // do some magic!
        return new ResponseEntity<CountryDTO>(HttpStatus.OK);
    }

}
